(* Definiert geometrische Punkte mit x- und y-Koordinate *)

type point = {x:int;y:int}


(* Ein drawitem ist entweder ein Liniensegment, definiert 
   durch zwei Punkte, oder ein Textfeld an einer bestimmten
   Stelle mit einem bestimmten Inhalt *)

type drawitem = Segment of point * point | Text of point * string


(* ffnet ein Grafikfenster und stellt Linien und Textfelder 
   darin dar *)

val draw_it : drawitem list -> unit


(* Bestimmt die ntige Grsse eines Textfeldes fr eine 
   Zeichenkette *)

val text_size : string -> int * int


(* bestimmt die Breite des Grafikfensters (wird nicht gebraucht) *)

val size_x : unit -> int


(* bestimmt die Hhe des Grafikfensters (wird nicht gebraucht) *)

val size_y : unit -> int


