open Lex
open Parse
open Visualise
open Graph
open Norm

(* wird bennutzt, um anzuzuegen, ob -n eingegeben wurde oder nicht *)

type flag_t = Normalise | Do_not_normalise


(* gitb Fehlermeldung aus *)

let falscher_aufruf() = print_string ((Sys.argv.(0)) ^ " [-n] " ^ "expression\n")


(* ruft Lexer, Parser, Grafikausgabe etc. auf *)

let doit flag s = 
  let lu = {x=0;y=0} in
  let ro = {x=600;y=450} in
  let e = parse (lex s) in
  let (todraw,toprint) = 
    match flag with
          Do_not_normalise -> ( (fun _ -> draw_expr e lu ro) , string_of_expr e )
        | Normalise        -> let ne = normalise e in 
                              ( (fun _ -> draw_expr ne lu ro) , string_of_expr ne )
  in 
  print_string (toprint ^ "\n") ; 
  try draw_it (todraw ()) with
      ParseError -> print_string "Syntaxfehler"
    | IllegalSymbol c -> (print_string "Falsches Symbol: ";print_char c)
    | e -> ()


(* ist das eigentlich Hauptprogramm ; liest Parameter ein *)

let _ = 
  let nb_parms = Array.length(Sys.argv) in
  if nb_parms <= 1 then falscher_aufruf()
  else if nb_parms = 2 && Sys.argv.(1) != "-n" then doit Do_not_normalise Sys.argv.(1)
       else if nb_parms = 3 then ( let arg1 = Sys.argv.(1) in 
                                   let arg2 = Sys.argv.(2) in 
                                   if arg1 = "-n" then doit Normalise arg2 
                                   else if arg2 = "-n" then doit Normalise arg1 
                                        else falscher_aufruf() )
            else falscher_aufruf()
    
